unit Dialogs;
{Diverse Dialogfenster}
interface

uses WinProcs,WinTypes,OWindows,ODialogs,objects,
 smsh,smsp,loadsave,umstep,strings;

const
 ID_RangeFrom=101;
 ID_RangeToPos=102;
 ID_RangeStep=103;
 ID_RbStepW=104;
 ID_RbSteps=105;
 ID_RbKey=106;
 ID_RbWait=107;
 ID_RangeWait=108;

type
PBereichDlg=^TBereichDlg;
TBereichDlg=object(TDialog)
 LRange: TRange;
 procedure SetupWindow; virtual;
 procedure IDHilfe(var Msg:TMessage); virtual ID_First+ID_Hilfe;
 procedure IDRbWeite(var Msg:TMessage); virtual ID_First+ID_RbStepW;
 procedure IDRbSchritte(var Msg:TMessage); virtual ID_First+ID_RbSteps;
 procedure IDRbTaste(var Msg:TMessage); virtual ID_First+ID_RbKey;
 procedure IDRbWarte(var Msg:TMessage); virtual ID_First+ID_RbWait;
 function GetX:boolean;
 function GetT:boolean;
 function GetAEXT:Boolean;
 procedure SetAEXT;
 function CanClose:Boolean; virtual;
end;

{************************************************************}

const
 ID_Proceed=101;
 ID_Timer=ID_StepDlg;

type
 PStepDlg=^TStepDlg;
 TStepDlg=object(TDialog)
  procedure SetupWindow; virtual;
  procedure IDProceed(var Msg:TMessage); virtual ID_First+ID_Proceed;
  procedure WMTimer(var Msg:TMessage); virtual WM_First+WM_Timer;
  procedure WMMovEnd(var Msg:TMessage); virtual WM_First+WM_MovEnd;
  destructor Done; virtual;
 end;

{************************************************************}

const
 ID_UnitName	=101;
 ID_StepsPerUnit=102;
 ID_MaxSpeed	=103;
 ID_RefSpeed	=104;
 ID_MaxAccel	=105;
 ID_RefPoint	=106;
 ID_LeftBound	=107;
 ID_RightBound	=108;
 ID_FastRefOfs	=109;
 ID_Hilfe	=998;

type
PGrenzenDlg=^TGrenzenDlg;
TGrenzenDlg=object(TDialog)
 LMotorR: TMotorR;
 procedure SetupWindow; virtual;
 procedure IDHilfe(var Msg:TMessage); virtual ID_First+ID_Hilfe;
 function CanClose:Boolean; virtual;
end;

{************************************************************}
const
 ID_EdConfig	=101;
 ID_New		=121;
 ID_Delete	=118;

type
PMotorSelDlg=^TMotorSelDlg;
TMotorSelDlg=object(TDialog)
 procedure SetupWindow; virtual;
 procedure IDNew(var Msg:TMessage); virtual ID_First+ID_New;
 procedure IDDelete(var Msg:TMessage); virtual ID_First+ID_Delete;
 procedure IDHilfe(var Msg:TMessage); virtual ID_First+ID_Hilfe;
 function CanClose:Boolean; virtual;
end;

{************************************************************}
const
 ID_CBSel=101;


type
PMSelDlg=^TMSelDlg;
TMSelDlg=object(TDialog)
 procedure SetupWindow; virtual;
 procedure IDHilfe(var Msg:TMessage); virtual ID_First+ID_Hilfe;
 function CanClose:Boolean; virtual;
end;

{************************************************************}
implementation

procedure TBereichDlg.SetupWindow;
 begin
  inherited SetupWindow;
  LRange:=Range;
  with LRange do begin
   SetAEXT;
   CheckRadioButton(HWindow,ID_RbStepW,ID_RbSteps,
    ID_RbStepW+Word(StepCheck));
   CheckRadioButton(HWindow,ID_RbKey,ID_RbWait,
    ID_RbKey+Word(WaitCheck));
   EnableWindow(GetDlgItem(HWindow,ID_RangeWait),WaitCheck);
  end;
 end;

procedure TBereichDlg.IDHilfe(var Msg:TMessage);
 var
  S: TS31;
 begin
  WinHelp(HWindow,HelpFileName,HELP_Context,ID_Bereich);
 end;

procedure TBereichDlg.IDRbWeite(var Msg:TMessage);
 begin
  if Msg.lParamHi=BN_Clicked then begin
   GetAEXT;
   LRange.StepCheck:=false;
   SetAEXT;
  end;
 end;

procedure TBereichDlg.IDRbSchritte(var Msg:TMessage);
 begin
  if Msg.lParamHi=BN_Clicked then begin
   GetAEXT;
   LRange.StepCheck:=true;
   SetAEXT;
  end;
 end;

procedure TBereichDlg.IDRbTaste(var Msg:TMessage);
 begin
  if Msg.lParamHi=BN_Clicked then begin
   LRange.WaitCheck:=false;
   EnableWindow(GetDlgItem(HWindow,ID_RangeWait),false);
  end;
 end;

procedure TBereichDlg.IDRbWarte(var Msg:TMessage);
 begin
  if Msg.lParamHi=BN_Clicked then begin
   LRange.WaitCheck:=true;
   EnableWindow(GetDlgItem(HWindow,ID_RangeWait),true);
   SetFocus(GetDlgItem(HWindow,ID_RangeWait));
  end;
 end;

{Schrittweite ermitteln; From und ToPos mssen eingelesen sein!}
function TBereichDlg.GetX:boolean;
 begin
  with LRange do begin
   GetX:=false;
   if GetReal(HWindow,ID_RangeStep,Step) then begin
    if StepCheck then begin
     if Step>0 then begin		{Nur positive Schritt-Zahlen}
      Step:=(ToPos-From)/Step;
      GetX:=true;
     end;
    end else begin
     if (ToPos-From)*Step<0 then Step:=-Step;
     if (ToPos-From)*Step>0 then begin
      GetX:=true;		{okay wenn gleiche Richtung und wenn <>0}
     end;
    end;
   end;
  end;
 end;

function TBereichDlg.GetT:boolean;
 begin
  with LRange do begin
   Wait:=GetDlgItemInt(HWindow,ID_RangeWait,nil,false);
   GetT:= not WaitCheck or (Wait<>0);
  end;
 end;

function TBereichDlg.GetAEXT:Boolean;
 begin
  with LRange do begin
   GetAEXT:=GetReal(HWindow, ID_RangeFrom,From)
       and GetReal(HWindow, ID_RangeToPos,ToPos)
       and GetX
       and GetT;
  end;
 end;

procedure TBereichDlg.SetAEXT;
 var
  S: TS31;
 begin
  with LRange do begin
   Real2S(From,3,S);
   SetDlgItemText(HWindow,ID_RangeFrom,S);
   Real2S(ToPos,3,S);
   SetDlgItemText(HWindow,ID_RangeToPos,S);
   if StepCheck then
    Real2S((ToPos-From)/Step,0,S)
   else
    Real2S(Step,3,S);
   SetDlgItemText(HWindow,ID_RangeStep,S);
   SetDlgItemInt(HWindow,ID_RangeWait,Wait,false);
  end;
 end;

function TBereichDlg.CanClose:Boolean;
 begin
  if GetAEXT then begin
   Range:=LRange;	{Alles rckschreiben}
   if AutoSave then SaveRange(CurrentConfig);
   CanClose:=true;
  end else begin
   CanClose:=Hinweis1(HWindow,ST_BereichFehler,nil)=IDCancel;
  end;
 end;

{************************************************************}

procedure TStepDlg.SetupWindow;
 begin
  inherited SetupWindow;
  InformDlg:=HWindow;	{Rckinformation}
  SendMessage(Parent^.HWindow,WM_Proceed,1,0);	{Initialisieren}
 end;

{"Weiter"-Taste gedrckt; sie bricht ggf. die Wartezeit ab!}
procedure TStepDlg.IDProceed(var Msg:TMessage);
 begin
  WMTimer(Msg);
 end;

procedure TStepDlg.WMTimer(var Msg:TMessage);
 begin
  KillTimer(HWindow,ID_Timer);
  if SendMessage(Parent^.HWindow,WM_Proceed,0,0)=0
  then EndDlg(0);	{Ende und alles fertig!}
 end;

procedure TStepDlg.WMMovEnd(var Msg:TMessage);
 begin
  if Range.WaitCheck then	{Stillstandszeit starten}
  SetTimer(HWindow,ID_Timer,Range.Wait,nil);
 end;

destructor TStepDlg.Done;
 begin
  KillTimer(HWindow,ID_Timer);
  InformDlg:=0;
  inherited Done;
 end;

{************************************************************}

procedure TGrenzenDlg.SetupWindow;
 var
  S,S1: TS31;	{kurzer String}
  SP: PChar;	{Hilfsvariable fr wvsprintf}
  Wnd: HWnd;
 begin
  inherited SetupWindow;
  LMotorR:=MotorR;
  with LMotorR do begin
   SP:=UnitName;
   Wnd:=GetWindow(HWindow,GW_Child);
   while Wnd<>0 do begin
    GetWindowText(Wnd,S,sizeof(S));
    wvsprintf(S1,S,SP);
    SetWindowText(Wnd,S1);
    Wnd:=GetWindow(Wnd,GW_HWndNext);
   end;
   Real2S(RefSpeed,3,S);	SetDlgItemText(HWindow,ID_RefSpeed,S);
   Real2S(MaxSpeed,3,S);	SetDlgItemText(HWindow,ID_MaxSpeed,S);
   Real2S(MaxAccel,3,S);	SetDlgItemText(HWindow,ID_MaxAccel,S);
   Real2S(RefPoint,3,S);	SetDlgItemText(HWindow,ID_RefPoint,S);
   Real2S(LeftBound,3,S);	SetDlgItemText(HWindow,ID_LeftBound,S);
   Real2S(RightBound,3,S);	SetDlgItemText(HWindow,ID_RightBound,S);
   Real2S(StepsPerUnit,3,S);	SetDlgItemText(HWindow,ID_StepsPerUnit,S);
   Real2S(FastRefOfs,3,S);	SetDlgItemText(HWindow,ID_FastRefOfs,S);
   SetDlgItemText(HWindow,ID_UnitName,UnitName);
  end;
 end;

procedure TGrenzenDlg.IDHilfe(var Msg:TMessage);
 var
  S: TS31;
 begin
  WinHelp(HWindow,HelpFileName,HELP_Context,ID_Grenzen);
 end;

function TGrenzenDlg.CanClose:Boolean;
 var
  S: TS31;
  Z: Real;
  I: Integer;
 begin
  with LMotorR do begin
   GetDlgItemText(HWindow,ID_UnitName,UnitName,sizeof(UnitName));
   if GetReal(HWindow,ID_StepsPerUnit,StepsPerUnit)
   and GetReal(HWindow,ID_RefSpeed,RefSpeed)
   and GetReal(HWindow,ID_MaxSpeed,MaxSpeed)
   and GetReal(HWindow,ID_MaxAccel,MaxAccel)
   and GetReal(HWindow,ID_RefPoint,RefPoint)
   and GetReal(HWindow,ID_LeftBound,LeftBound)
   and GetReal(HWindow,ID_RightBound,RightBound)
   and GetReal(HWindow,ID_FastRefOfs,FastRefOfs)
   and (LeftBound<=RefPoint)
   and (RefPoint<=RightBound)
   and (StepsPerUnit<>0.0)	{Negatives Vorzeichen kehrt Richtung um!}
   then begin
    MotorR:=LMotorR;
    if AutoSave then SaveMotorR(CurrentConfig);
    CanClose:=true;
   end else begin
    CanClose:=Hinweis1(HWindow,ST_BereichFehler,nil)=IDCancel;
   end;
  end;
 end;

{************************************************************}

procedure TMotorSelDlg.SetupWindow;
 var
  S:TS255;
  SP:PChar;
  I,W: Word;
 begin
  inherited SetupWindow;
  if LongRec(CurrentConfig).Hi<>0 then begin
   SetDlgItemText(HWindow,ID_EdConfig,CurrentConfig);
   EnableWindow(GetItemHandle(ID_EdConfig),false); {Editfeld deaktivieren}
   EnableWindow(GetItemHandle(ID_New),true);	{Schalter "Neu" aktivieren}
   EnableWindow(GetItemHandle(ID_Delete),true);	{Schalter "Lschen" -"-}
  end;
  W:=AMotor.CFlags;
  for I:=103 to 107 do begin
   CheckDlgButton(HWindow,I,W and 1);		{Ankreuzfelder}
   W:=W shr 1;
  end;
  CheckDlgButton(HWindow,108+W,1);		{Wellenschalter "Kurvenform}
  W:=AMotor.HWEMask; wvsprintf(S,'%02X',W); SetDlgItemText(HWindow,112,S);
  W:=AMotor.HWEXor; wvsprintf(S,'%02X',W); SetDlgItemText(HWindow,113,S);
  wvsprintf(S,'%03X',AMotor.PortHWE); SetDlgItemText(HWindow,114,S);
  wvsprintf(S,'%03X',AMotor.PortA); SetDlgItemText(HWindow,115,S);
  wvsprintf(S,'%03X',AMotor.PortB); SetDlgItemText(HWindow,116,S);
 end;

procedure TMotorSelDlg.IDNew(var Msg:TMessage);
 begin
  EnableWindow(GetItemHandle(ID_EdConfig),true);	{Editfeld aktivieren}
  SendDlgItemMsg(ID_EdConfig,EM_SetSel,0,$FFFF0000);	{Alles markieren}
  SetFocus(GetItemHandle(ID_EdConfig));		{fokussieren}
  EnableWindow(GetItemHandle(ID_New),false);	{Schalter "Neu" deaktivieren}
  EnableWindow(GetItemHandle(ID_Delete),false);	{Schalter "Lschen" -"-}
 end;

procedure TMotorSelDlg.IDDelete(var Msg:TMessage);
 begin
  if Hinweis(HWindow,ST_Sure,CurrentConfig)=IDOK then begin
   SendMessage(Parent^.HWindow,WM_Assign,0,0);	{Aktiven Motor lschen}
   WritePrivateProfileString('Motors',CurrentConfig,nil,Profile);
   EndDlg(0);					{Ende mit Dialog}
  end;
 end;

procedure TMotorSelDlg.IDHilfe(var Msg:TMessage);
 begin
  WinHelp(HWindow,HelpFileName,HELP_Context,ID_Connect);
 end;

function TMotorSelDlg.CanClose:Boolean;
 var
  S:TS31;
  I,W: Word;
  EC,EW:Word;
 begin
  SMGetMotor(AMotor.Handle,AMotor);	{Evtl. Vernderungen bei Grenzen??}
  for I:=108 to 111 do if IsDlgButtonChecked(HWindow,I)=1 then break;
  W:=I-108;
  for I:=107 downto 103 do begin
   W:=W shl 1 + IsDlgButtonChecked(HWindow,I);
  end;
  AMotor.CFlags:=W;
  repeat
   EC:=ST_BadHex;
   EW:=112; if not GetDlgItemHex(HWindow,EW,W) then break; AMotor.HWEMask:=W;
   EW:=113; if not GetDlgItemHex(HWindow,EW,W) then break; AMotor.HWEXor:=W;
   EW:=114; if not GetDlgItemHex(HWindow,EW,AMotor.PortHWE) then break;
   EW:=115; if not GetDlgItemHex(HWindow,EW,AMotor.PortA) then break;
   EW:=116; if not GetDlgItemHex(HWindow,EW,AMotor.PortB) then break;
   EC:=ST_NameRequired; EW:=ID_EdConfig;
   if IsWindowEnabled(GetItemHandle(EW)) then begin {Neuer Motor?}
    if GetDlgItemText(HWindow,EW,S,sizeof(S))=0 then break;
    EC:=ST_AlreadyExist;
    if GetPrivateProfileInt('Motors',S,0,Profile)=1 then break;
    SendMessage(Parent^.HWindow,WM_Assign,0,LongInt(@S));
   end else begin
    EC:=SMSetMotor(false,AMotor);	{Nur neue Parameter setzen}
    if EC<>0 then break;		{Fehler aufgetreten!}
   end;
   EW:=0;
  until true;
  if EW=0 then CanClose:=true
  else begin
   SendDlgItemMsg(EW,EM_SetSel,0,$FFFF0000);	{Markieren}
   SetFocus(GetItemHandle(EW));			{Fokussieren}
   Hinweis1(HWindow,EC,S);			{Anmeckern}
  end;
 end;

{************************************************************}

procedure TMSelDlg.SetupWindow;
 var
  S: array[0..1023] of Char;
  SP:PChar;
  I,W: Word;
 begin
  inherited SetupWindow;
  LoadString(Seg(HInstance),ST_None,S,sizeof(S));	{"[kein]"}
  SendDlgItemMsg(ID_CbSel,CB_AddString,0,LongInt(@S));
  GetPrivateProfileString('Motors',nil,'',S,sizeof(S),Profile);
  SP:=S;			{Laufzeiger}
  while SP^<>#0 do begin
   SendDlgItemMsg(ID_CbSel,CB_AddString,0,LongInt(SP));
   SP:=StrEnd(SP)+1;		{hinter die Null!}
  end;
  if LongRec(CurrentConfig).Hi<>0
  then SendDlgItemMsg(ID_CbSel,CB_SelectString,Word(-1),LongInt(CurrentConfig))
  else SendDlgItemMsg(ID_CbSel,CB_SetCurSel,0,0);
 end;

procedure TMSelDlg.IDHilfe(var Msg:TMessage);
 begin
  WinHelp(HWindow,HelpFileName,HELP_Context,ID_Connect);
 end;

function TMSelDlg.CanClose:Boolean;
 var
  W,Answer: Word;
  S: TS31;
  SP: PChar;
 begin
  W:=SendDlgItemMsg(ID_CbSel,CB_GetCurSel,0,0);
  SP:=nil;
  if W<>0 then begin
   SendDlgItemMsg(ID_CbSel,CB_GetLBText,W,LongInt(@S));
   SP:=S;
  end;
  CanClose:=SendMessage(Parent^.HWindow,WM_Assign,0,LongInt(SP))=0;
 end;

end.
