{$A+,B-,G+,F-,K+,W-}		{Standard-Codeerzeugung}
{$P-,T-,V+,X+}			{Compiler-Prfungen}
{$D+,I+,L+,Q+,R+,S+,Y+} 	{Debug-Codeerzeugung}
{ $D-,I-,L-,Q-,R-,S-,Y-} 	{Release-Codeerzeugung}
{$N+,E-}			{TReal=Real, hier kein Kopro erforderlich}
{$M 8192,8192}
program MotorSt;

{$R MotorSt.res}
{$D Schrittmotor-DDE-Server}
{$C Moveable Preload Discardable}
{$S $8000}	{Units automatisch gruppieren, weniger Far-Calls und Fixups}

uses WinProcs,WinTypes,OWindows,ODialogs,Win31,DdeMl,Strings,
 umstep,smsh,smsp,smsdde,Dialogs,LoadSave,windos;


{*********************************}
{Hauptfenster-Dialogobjekt mit DDE}
{*********************************}
type
 PMain=^TMain;
 TMain=object(TDlgWindow)
  Synced: Bool;		{Synchronzustand, DDE-abfragbar}
  InMove: Bool;		{In-Bewegung, DDE-abfragbare Variable}
  MStrom: Bool;		{Status: Motorspulen bestromt oder stromfrei}
			{bzw. Bremse angezogen oder nicht}
  InInit: Bool;		{DDE-Funktion INIT in Ausfhrung}
  MovReq: Bool;		{1 Move-Befehl in Warteschlange (NextPos)}
  CurPos: TReal;
  NextPos:TReal;
  {Dialog-Elemente}
  SbGrob: PScrollBar;			{Visualisierung der Motorposition}
  SbFein: PScrollBar;
  {DDE-Variablen}
  DdeServ: PMyDDE;			{initialisierte Instanz}

  {Methoden}
  procedure GetWindowClass(var AWndClass:TWndClass); virtual;
  procedure SetupWindow; virtual;
  function CanClose:Boolean; virtual;
  procedure WMInitMenu(var Msg:TMessage); virtual WM_First+WM_InitMenu;
  {Menkommandos}
  procedure CMMSel(var Msg:TMessage); virtual CM_First+CM_MSel;
  procedure CMEnde(var Msg:TMessage); virtual CM_First+CM_Ende;
  procedure CMConnect(var Msg:TMessage); virtual CM_First+CM_Connect;
  procedure CMBereich(var Msg:TMessage); virtual CM_First+CM_Bereich;
  procedure CMGrenzen(var Msg:TMessage); virtual CM_First+CM_Grenzen;
  procedure CMAutoSave(var Msg:TMessage); virtual CM_First+CM_AutoSave;
  procedure CMSaveNow(var Msg:TMessage); virtual CM_First+CM_SaveNow;
  procedure CMHilfeIndex(var Msg:TMessage); virtual CM_First+CM_HelpIndex;
  procedure CMAbout(var Msg:TMessage); virtual CM_First+CM_About;
  {Dialog-Kommandos}
  procedure IDSetNull(var Msg:TMessage); virtual ID_First+ID_Nullpunkt;
  procedure IDSbGrob(var Msg:TMessage); virtual ID_First+ID_SbGrob;
  procedure IDSbFein(var Msg:TMessage); virtual ID_First+ID_SbFein;
  procedure IDGoto(var Msg:TMessage); virtual ID_First+ID_Goto;
  procedure IDRefFahrt(var Msg:TMessage); virtual ID_First+ID_RefFahrt;
  procedure IDStop(var Msg:TMessage); virtual ID_First+ID_Stop;
  procedure IDFree(var Msg:TMessage); virtual ID_First+ID_Free;
  procedure IDInFahrt(var Msg:TMessage); virtual ID_First+ID_InFahrt;
  procedure IDDdeVerb(var Msg:TMessage); virtual ID_First+ID_DdeVerb;
  {DDE-Callbacks}
  procedure WMConnect(var Msg:TMessage); virtual WM_First+WM_Connect;
  procedure WMPoke(var Msg:TMessage); virtual WM_First+WM_Poke;
  procedure WMExecute(var Msg:TMessage); virtual WM_First+WM_Execute;
  procedure WMRequest(var Msg:TMessage); virtual WM_First+WM_Request;
  {VxD-Callback}
  procedure WMMovEnd(var Msg:TMessage); virtual WM_First+WM_MovEnd;
  {Rufe aus anderen Fenstern}
  procedure WMProceed(var Msg:TMessage); virtual WM_First+WM_Proceed;
  procedure WMAssign(var Msg:TMessage); virtual WM_First+WM_Assign;
  {Interne Funktionen}
  procedure SetTextStrings(Z: TReal);
  function DoReffahrt:boolean;
  function MoveMotorQuiet(nach: TReal):boolean;
  function MoveMotor(nach: TReal):boolean;
  procedure SetScrollbars(nach: TReal);
  procedure EnableButtons;
  procedure SetNewAlias;
  procedure SetInMove(AValue:Bool);
  procedure SetSynced(AValue:Bool);
  procedure SetMStrom(AValue:Bool);
  function AssignMotor(NewConfig: PChar):boolean;
  procedure SaveWindowPos;
 end;

procedure TMain.GetWindowClass(var AWndClass:TWndClass);
 begin
  inherited GetWindowClass(AWndClass);
  AWndClass.lpszClassName:=AppName;
  AWndClass.hIcon:=LoadIcon(hInstance,MakeIntResource(IDC_Main));
 end;

procedure TMain.SetupWindow;
 var
  EC: Integer;
  S:TS31;
  SysMenu: HMenu;
  SP: PChar;
  R: TRect;
  I: Integer;
 type
  PShow=^TShow;
  TShow=record
   Two, ShowCmd: Integer;
  end;
  TLoadParms=record
   segEnv: Word;
   lpszCommandLine: PChar;
   lpShow: PShow;
   lpReserved: Pointer;
  end;
 const
  AShow:TShow=(
   Two:		2;
   ShowCmd:	SW_Show);
  ALP:TLoadParms=(
   segEnv:	0;
   lpszCommandLine: nil;
   lpShow:	@AShow;
   lpReserved:	nil);
 begin
  SbGrob:=New(PScrollBar,InitResource(@self,ID_SbGrob));
  SbFein:=New(PScrollBar,InitResource(@self,ID_SbFein));
  InMove:=false;
  MovReq:=false;
  Synced:=false;
  MStrom:=false;
  InInit:=false;
  inherited SetupWindow;
  LongRec(AMotor.CallbackUser).Lo:=HWindow;
  LongRec(AMotor.CallbackUser).Hi:=WM_MovEnd;
  SysMenu:=GetSystemMenu(HWindow,false);
  DeleteMenu(SysMenu,SC_Zoom,MF_ByCommand);
  DeleteMenu(SysMenu,SC_Size,MF_ByCommand);
  AShow.ShowCmd:=CmdShow;
  ALP.lpszCommandLine:=S;
  for I:=1 to GetArgCount do begin
   GetArgStr(S,I,sizeof(S));
   if lstrcmpi(S,'/debug')=0 then NoMotor:=true
   else if LongRec(CurrentConfig).Hi=0 then AssignMotor(CmdLine)
   else LoadModule(MakeIntResource(Seg(HInstance)),@ALP);
  end;
  if LongRec(CurrentConfig).Hi=0 then begin
   if GetPrivateProfileString(Generic,'DefaultMotor','',
     S,sizeof(S),Profile)<>0
   then AssignMotor(S);
  end;

  {DDE weiter initialisieren}
  DdeServ:=New(PMyDDE,Init(HWindow));
  SetNewAlias;	{Alias je nach aktivem Motor setzen}
  SbFein^.SetRange(-100,100);	{Fein-Rollbalken-Parameter setzen}
  SbGrob^.SetRange(Trunc(MotorR.LeftBound+0.99),Trunc(MotorR.RightBound-0.01));
{Grob-Rollbalken-Rnder derart setzen, da niemals berlufe auftreten}
  SetScrollbars(0.0);
{Rollbalken mittig positionieren}
  EnableButtons;
  AutoSave:=GetPrivateProfileInt(Generic,'AutoSave',0,Profile)<>0;
  if AutoSave
  then CheckMenuItem(GetMenu(HWindow),CM_AutoSave,MF_ByCommand or MF_Checked);
  SP:=CurrentConfig; if LongRec(SP).Hi=0 then SP:=Generic;
  GetWindowRect(HWindow,R);
  Dec(R.right,R.left); Dec(R.bottom,R.top);
  R.left:=GetPrivateProfileInt(SP,'Window.Left',R.left,Profile);
  R.top:=GetPrivateProfileInt(SP,'Window.Top',R.top,Profile);
  MoveWindow(HWindow,R.left,R.top,R.right,R.bottom,false);
 end;

procedure TMain.WMInitMenu(var Msg:TMessage);
{Aufruf vom System vor dem ffnen des Mens:
 der "Bereich"-Menpunkt mu ggf. grau dargestellt werden}
 var
  WEnable:Word;
 begin
  if Synced then WEnable:=MF_Enabled
  else WEnable:=MF_Grayed;
  EnableMenuItem(GetMenu(HWindow),CM_Bereich,WEnable or MF_ByCommand);
 end;

procedure TMain.CMEnde(var Msg:TMessage);
 begin
  CloseWindow;
 end;

procedure TMain.CMBereich(var Msg:TMessage);
{Bereich abfahren: 2 Dialogfenster hintereinander (falls die erste mit OK
 beantwortet wurde)}
 begin
  if Application^.ExecDialog(New(PBereichDlg,
     Init(@Self,MakeIntResource(ID_Bereich))))=ID_OK then
   Application^.ExecDialog(New(PStepDlg,
    Init(@Self,MakeIntResource(ID_StepDlg))));
 end;

procedure TMain.CMConnect(var Msg:TMessage);
{Nicht DDE! Hiermit wird ein neuer Motor ausgewhlt}
 begin
  if Application^.ExecDialog(New(PMotorSelDlg,
     Init(@Self,MakeIntResource(ID_Connect))))=ID_OK then begin
   SetScrollbars(0.0);	{rcksetzen}
   SetTextStrings(0.0);	{Text auf Fragezeichen}
   SetNewAlias;		{fr DDE}
   EnableButtons;
  end;
 end;

procedure TMain.CMGrenzen(var Msg:TMessage);
{Neue Grenzen festlegen}
 begin
  if Application^.ExecDialog(New(PGrenzenDlg,
     Init(@Self,MakeIntResource(ID_Grenzen))))=ID_OK then begin
{Wegen der neuen Grenzen mssen die Rollbalken mit neuen Grenzen versorgt
 werden. Hierbei gengt der Grob-Rollbalken.}
   SbGrob^.SetRange(Trunc(MotorR.LeftBound+0.99),Trunc(MotorR.RightBound-0.01));
   SetMotorStruc;
   SMSetMotor(false,AMotor);
   SetDlgItemText(HWindow,ID_Einheit,MotorR.UnitName);
  end;
 end;

procedure TMain.CMAutoSave(var Msg:TMessage);
 var
  S: array[0..1] of Char;
  MC: Word absolute S;
 begin
  AutoSave:=not AutoSave;
  MC:=MF_ByCommand or MF_UnChecked;
  if AutoSave then MC:=MF_ByCommand or MF_Checked;
  CheckMenuItem(GetMenu(HWindow),CM_AutoSave,MC);
  MC:=Ord('0'); if AutoSave then MC:=Ord('1');
  WritePrivateProfileString(Generic,'AutoSave',S,Profile);
 end;

procedure TMain.CMSaveNow(var Msg:TMessage);
 begin
  if LongRec(CurrentConfig).Hi<>0 then SaveSet(CurrentConfig);
  SaveWindowPos;
 end;

procedure TMain.CMHilfeIndex(var Msg:TMessage);
 begin
  WinHelp(HWindow,HelpFileName,HELP_Index,0);
 end;

procedure TMain.CMAbout(var Msg:TMessage);
 begin
  Application^.ExecDialog(New(PDialog,Init(@Self,MakeIntResource(ID_About))));
 end;

procedure TMain.SaveWindowPos;
 var
  SP: PChar;
  S: TS31;
  R: TRect;
 begin
  SP:=CurrentConfig; if LongRec(SP).Hi=0 then SP:=Generic;
  GetWindowRect(HWindow,R);
  wvsprintf(S,'%d',R.left);
  WritePrivateProfileString(SP,'Window.Left',S,Profile);
  wvsprintf(S,'%d',R.top);
  WritePrivateProfileString(SP,'Window.Top',S,Profile);
 end;

function TMain.CanClose;
{Aufruf beim Beenden von MOTORST: Warnung ausgeben bei aktiver DDE-Verbindung}
 begin
  CanClose:=false;
  if IsDlgButtonChecked(HWindow,ID_DdeVerb)=1 then begin
   if Hinweis(HWindow,ST_BreakDde,CurrentConfig)<>IDOK then exit;
  end;
  if AutoSave then SaveWindowPos;
  WinHelp(HWindow,HelpFileName,HELP_Quit,0);
  Dispose(DdeServ,Done);
  AssignMotor(nil);	{Abmelden}
  Dispose(SbGrob,Done);
  Dispose(SbFein,Done);
  CanClose:=true;
 end;

procedure TMain.SetNewAlias;
{Neues DDE-Alias-Topic setzen, wird bei jedem Motorwechsel aufgerufen}
 const
  OldUnit: Byte=0;
 begin
  if AMotor.Handle<>OldUnit then begin
   if AMotor.Handle<>0 then begin
    DdeServ^.SetAlias(CurrentConfig);
   end else begin
    DdeServ^.SetAlias(nil);		{kein Alias!}
   end;
   OldUnit:=AMotor.Handle;
  end;
 end;

procedure TMain.SetInMove(AValue:Bool);
{Gesonderter Schreibzugriff auf DDE-kontrollierte Variable}
 begin
  if InMove<>AValue then begin
   InMove:=AValue;
   CheckDlgButton(HWindow,ID_InFahrt,Word(InMove)); {Lmpchen EIN oder AUS}
   EnableWindow(GetItemHandle(ID_InFahrt),InMove);
   DdeServ^.Advise(2);
  end;
 end;

procedure TMain.SetSynced(AValue:Bool);
{Gesonderter Schreibzugriff auf DDE-kontrollierte Variable}
 begin
  if Synced<>AValue then begin
   Synced:=AValue;
   EnableWindow(GetItemHandle(ID_Nullpunkt),Synced);
   DdeServ^.Advise(3);
  end;
 end;

procedure TMain.SetMStrom(AValue:Bool);
{Gesonderter Schreibzugriff auf DDE-kontrollierte Variable}
 begin
  if MStrom<>AValue then begin
   MStrom:=AValue;
  end;
  if MStrom=false then SetSynced(false);
 end;

procedure TMain.SetTextStrings(Z: TReal);
{Anzeige in den Editfenstern (absolute sowie relative Position)
 auf Z aktualisieren, hierbei erfolgt KEIN DDE-Advise!
 Ein Fragezeichen wird angezeigt, wenn die Position ungltig ist}
 var
  S: TS31;
 begin
  if Synced then
   Real2S(Z,3,S)
  else
   lStrCpy(S,'?');
  SetDlgItemText(HWindow,ID_AbsWert,S);
 end;

procedure TMain.IDSbGrob(var Msg:TMessage);
{Beim Bewegen des Thumbs mit der Maus sollen die Anzeige (Editfenster)
 mitlaufen; beim Loslassen schlielich soll die Bewegung dahin initiiert
 werden. Dasselbe gilt beim Loslassen der Cursortaste
 Auerdem wird LastFocusedEdit zurckgesetzt, damit der Knopf "Zur Position"
 eine Fehlermeldung auslst (nun, man knnte ihn auch deaktivieren...)}
 var
  Z:TReal;
 begin
  Z:=SbGrob^.GetPosition+SbFein^.GetPosition/100;
  SetTextStrings(Z);
  if Msg.wParam=SB_EndScroll then begin
{   MessageBeep(Word(-1));}
   if Synced then begin
    MoveMotor(Z);
   end else begin
    Hinweis1(HWindow,ST_NoReffahrt,nil);
   end;
  end;
 end;

procedure TMain.IDSbFein(var Msg:TMessage);
{Tatschlich gengt es hier, dieselbe Routine wie bei IDSBGROB zu benutzen}
 begin
  IDSbGrob(Msg);
 end;

procedure TMain.IDRefFahrt(var Msg:TMessage);
{...beim Drcken auf den Knopf "Referenzfahrt"}
 var
  Z: TReal;
 begin
  if Synced then begin
   Z:=Abs(MotorR.FastRefOfs);
   if MotorR.RefSpeed>0 then Z:=-Z;
   if MotorR.StepsPerUnit<0 then Z:=-Z;
   Z:=Z+MotorR.RefPoint;
   MoveMotor(Z);  {10 neben dem Referenzschalter auf der richtigen Seite}
   while InMove do ShortYield;	{Warten bis Ende}
  end else begin
   if (AMotor.CFlags and MC_Observe =0)
   and (Hinweis(HWindow,ST_StartReffahrt,CurrentConfig)<>IDOK)
   then exit;
  end;
  SetSynced(false);
  if DoReffahrt then begin {Referenzfahrt durchfhren}
   MoveMotor(0.0);	{Rckbewegung in Warteschlange stellen}
  end else begin
   Hinweis(HWindow,ST_BadReffahrt,CurrentConfig);
  end;
 end;

procedure TMain.IDStop(var Msg:TMessage);	{Knopf "Stop"}
 begin
  MovReq:=false;		{Queue leeren}
  SMStop(AMotor.Handle);	{Motor anhalten, das Callback kommt}
 end;

procedure TMain.IDFree(var Msg:TMessage);	{Knopf "Frei"}
 begin
  MovReq:=false;	{Queue leeren}
  SMFree(AMotor.Handle);
 end;

procedure TMain.IDInFahrt(var Msg:TMessage);	{Knopf "InFahrt"}
 begin
  IDStop(Msg);			{Bewegung stoppen}
 end;

procedure TMain.IDDdeVerb(var Msg:TMessage);	{Knopf "DDE-Verbindung"}
 begin
  DdeServ^.DisconnectLast;			{DDE-Verbindung(en) killen}
 end;

{Diese Funktion meldet den Motor an und ggf. den alten Motor ab
 Mit NIL wird der Motor nur abgemeldet!
 Funktion liefert TRUE, wenn Anmeldung okay
 Solcherart Funktionen sind brigens typisch fr SDI-Programme}
function TMain.AssignMotor(NewConfig:PChar):boolean;
 label l1;
 var
  S,S1: TS31;
  Force:Boolean;
 begin
  AssignMotor:=false;
  if (AMotor.Handle<>0) then begin
   SetMStrom(false);
   SMStop(AMotor.Handle);
   SMRemoveMotor(AMotor.Handle);
   AMotor.Handle:=0;	{Motor abmelden}
  end;
  StrDispose(CurrentConfig); CurrentConfig:=nil;
  if NewConfig<>nil then begin
   LoadSet(NewConfig);
   Force:=false;
   while SMSetMotor(Force,AMotor)<>0 do begin
    case MessageBox(HWindow,'Alloc-Fehler!',nil,MB_AbortRetryIgnore) of
     ID_Retry: ;
     ID_Ignore: Force:=true;
     ID_Abort: goto l1;
    end;
   end;
   CurrentConfig:=StrNew(NewConfig);
l1:
  end;
  LoadString(Seg(HInstance),ST_NewTitle,S,sizeof(S));
  wvsprintf(S1,S,CurrentConfig);
  SetWindowText(HWindow,S1);
  SetDlgItemText(HWindow,ID_Einheit,MotorR.UnitName);
 end;

procedure TMain.WMConnect(var Msg:TMessage);
{DDE-Verbindung, wParam enthlt Zustand, ob DDE aktiv oder nicht (mehr)}
 begin
  CheckDlgButton(HWindow,ID_DdeVerb,Msg.wParam);
  EnableWindow(GetItemHandle(ID_DdeVerb),Bool(Msg.wParam));
{Rckgaben von Dialogfenstern sind nur so mglich!}
  SetWindowLong(hWindow,DWL_MsgResult,1);
 end;

procedure TMain.WMPoke(var Msg:TMessage);
{DDE-Poke auf ein Datenelement (nur CF_Text),
 wParam=Nummer (1-basiert), lParam=Stringzeiger}
 var
  Z:TReal;
 begin
  Msg.Result:=DDE_fNotProcessed;
  case Msg.wParam of
   1: if S2Real(PChar(Msg.lParam),Z) then
       if InInit then Msg.ResultLo:=DDE_fBusy
       else if MoveMotorQuiet(Z) then
       Msg.ResultLo:=DDE_fAck;

   2,3: ;	{Kein POKE fr Variablen InMove und Synced zulassen!}
  end;
  SetWindowLong(hWindow,DWL_MsgResult,Msg.Result);
 end;

procedure TMain.WMExecute(var Msg:TMessage);
{DDE-Execute (nur CF_Text), lParam=Stringzeiger}
 var
  Z: TReal;
 begin
  Msg.Result:=DDE_fNotProcessed;
  if (StrLIComp(PChar(Msg.lParam),'Move',4)=0)
  and S2Real(@(PChar(Msg.lParam)[4]),Z) then begin
   if InInit then Msg.ResultLo:=DDE_fBusy
   else if MoveMotorQuiet(Z)
   then Msg.ResultLo:=DDE_fAck
  end else if lStrCmpi(PChar(Msg.lParam),'Sync')=0 then begin
   if InInit then Msg.ResultLo:=DDE_fBusy
   else if DoReffahrt 	{Nur Referenzfahrt (sozusagen "still")}
   then Msg.ResultLo:=DDE_fAck
  end else if lStrCmpi(PChar(Msg.lParam),'Init')=0 then begin
   InInit:=true;
   IDRefFahrt(Msg);	{dasselbe wie beim Drcken der Taste tun}
   while InMove or MovReq do ShortYield; {Zurckkehren erst, wenn fertig!}
   InInit:=false;
   if Synced then
    Msg.ResultLo:=DDE_fAck;	{OK melden, wenn synchronisiert}
  end else if lStrCmpi(PChar(Msg.lParam),'Stop')=0 then begin
   if SMStop(AMotor.Handle)=0
   then Msg.ResultLo:=DDE_fAck
  end else if lStrCmpi(PChar(Msg.lParam),'Free')=0 then begin
   if SMFree(AMotor.Handle)=0 then begin
    SetMStrom(false);
    Msg.ResultLo:=DDE_fAck;
   end;
  end;
  SetWindowLong(hWindow,DWL_MsgResult,Msg.Result);
 end;

procedure TMain.WMRequest(var Msg:TMessage);
{DDE-Request auf ein Datenelement (nur CF_Text),
 wParam=Nummer (1-basiert), lParam=Stringzeiger
 Die zur Verfgung gestellte Stringlnge ist hierbei 32 Bytes (TS31)}
 begin
  Msg.Result:=1;
  case Msg.wParam of
   1: Real2S(CurPos,3,PChar(Msg.lParam));
   2: wvsprintf(PChar(Msg.lParam),'%d',InMove);
   3: wvsprintf(PChar(Msg.lParam),'%d',Synced);
   else Msg.ResultLo:=0;
  end;
  SetWindowLong(hWindow,DWL_MsgResult,Msg.Result);
 end;

{Vom VxD gerufene Bewegungsende-Routine}
procedure TMain.WMMovEnd(var Msg:TMessage);
 var
  S:TS31;
 begin
  if Msg.wParamHi and MF_Synced <>0 then begin
   SetSynced(true);
   CurPos:=Msg.lParam/256/MotorR.StepsPerUnit; DdeServ^.Advise(1);
   SetScrollbars(CurPos);
   SetTextStrings(CurPos);
{   wvsprintf(S,'Msg.lParam (Position) = %ld',Msg.lParam);
   MessageBox(HWindow,S,'Test WMMovEnd',0);}
  end else SetSynced(false);
  SetInMove(false);
  if MovReq then begin
   MoveMotor(NextPos);
   MovReq:=false;
  end else begin
   CheckDlgButton(HWindow,ID_InFahrt,0);	{Lmpchen AUS}
   EnableButtons;		{Ggf. Schalter aktivieren}
  end;
  if InformDlg<>0 then		{Kindfenster informieren}
   SendMessage(InformDlg,WM_MovEnd,Msg.wParam,Msg.lParam);
 end;

{Vom untergeordneten Dialogfenster gerufene Routine, in wParam
steht ein BOOL, ob eine Initialisierung stattfinden soll}
procedure TMain.WMProceed(var Msg:TMessage);
 const
  MemPos: TReal=0.0;		{Statische Variable, die nur hier gltig ist}
 begin
  Msg.Result:=0;
  with Range do begin
   MemPos:=MemPos+Step;
   if Msg.wParam<>0 then		{Initialisierung (Fahrt zum Startpunkt)?}
    MemPos:=From;		{Ja!}
 {Je nach Fahrtrichtung Endebedingung prfen}
   if (Step<0) and (MemPos>=ToPos)
   or (Step>0) and (MemPos<=ToPos) then begin
    if MoveMotor(MemPos) then
     Msg.ResultLo:=1;		{als auch ber "Umweg"}
   end;
  end;
  SetWindowLong(hWindow,DWL_MsgResult,Msg.Result);
 end;

{Vom untergeordneten Dialogfenster gerufene Routine zum Neuzuweisen
 des Motors, lParam enthlt die neue Motor-Sektion}
procedure TMain.WMAssign(var Msg:TMessage);
 begin
  AssignMotor(PChar(Msg.lParam));
 end;

procedure TMain.IDGoto;
{Knopf "Zur Position": Je nach zuletzt aktiviertem Dialogelement
 * relative Position anfahren oder
 * absolute Position anfahren oder
 * Fehlermeldung ausgeben}
 var
  S: TS31;
  Z: TReal;
 begin
  GetDlgItemText(HWindow,ID_AbsWert,S,sizeof(S));
  if S2Real(S,Z) and (AMotor.Handle<>0) then begin
  MoveMotor(Z);
  end else begin
   Hinweis1(HWindow,ST_BadNumber,S);
  end;
  SetFocus(GetItemHandle(ID_AbsWert));
	{Zurckfokussieren, damit der User sieht, welchen Wert er setzte}
{  SendDlgItemMessage(HWindow,LastFocusedEdit,EM_SetSel,0,MakeLong(0,$FFFF));
   {und alles markieren, damit gleich ein neuer Wert eingegeben werden kann}
 end;

procedure TMain.IDSetNull;
{Knopf "Nullpunkt setzen"}
 var
  S: TS31;
  Z: TReal;
 begin
  GetDlgItemText(HWindow,ID_AbsWert,S,sizeof(S));
  if S2Real(S,Z) then begin
   if Abs(Z)<Abs(MotorR.FastRefOfs) then begin
    SetTextStrings(Z);	{logischerweise wird RelPos nun 0}
    Ddeserv^.Advise(1);	{Neue Relativposition!}
   end else begin
    Hinweis1(HWindow,ST_BadZeroRange,S);
   end;
  end else begin
   Hinweis1(HWindow,ST_BadNumber,S);
  end;
 end;

procedure TMain.SetScrollbars(nach: TReal);
{Interne Routine zum Setzen der Rollbalken auf einen bestimmten Punkt,
 z.B. bei Bewegungsende}
 var
  p1,p2:Integer;
 begin
  p1:=Round(nach);		{Gerundeter Wert}
  p2:=Round((nach-p1)*100);	{Verbleibende Differenz}
  SbGrob^.SetPosition(p1);
  SbFein^.SetPosition(p2);
 end;

procedure TMain.EnableButtons;
{Generalroutine, die je nach diversen programmglobalen Flags die Tasten
 freischaltet oder sperrt. Lt. Dok. prft EnableWindow() zuerst den
 Momentanzustand eines Fensters.}
 var
  B: Bool;
 begin
{  B:=Synced;
  EnableWindow(GetItemHandle(ID_Goto),B);}
  B:=InMove;
  EnableWindow(GetItemHandle(ID_Stop),B);
  B:=AMotor.Handle<>0;
  EnableWindow(GetItemHandle(ID_Reffahrt),B);
  B:=B and MStrom;
  EnableWindow(GetItemHandle(ID_Free),B);
 end;

function TMain.DoReffahrt:boolean;
{Knopf "Referenzfahrt"}
 begin
  DoReffahrt:=false;
  SetMStrom(true);
  if SMSync(AMotor.Handle)=0 then begin
   SetInMove(true);
   EnableButtons;
   DoReffahrt:=true;
  end;
 end;

function TMain.MoveMotorQuiet(nach: TReal):boolean;
{Motor auf neue Position setzen ohne Messagebox bei Fehler (fr DDE)}
 begin
  if InMove then begin	{Gerade beschftigt?}
   NextPos:=nach;	{Anforderung in Warte"schlange" stellen}
   MovReq:=true;
   MoveMotorQuiet:=true;	{und "okay" melden}
  end else begin
   if SMMoveAbs(AMotor.Handle,Round(Nach*256*MotorR.StepsPerUnit))=0 then begin
    SetInMove(true);
    MoveMotorQuiet:=true;
   end else begin
    MoveMotorQuiet:=false;
   end;
  end;
 end;

function TMain.MoveMotor(nach: TReal):boolean;
{Motor auf neue Position setzen, mit Messagebox bei Fehler}
 var
  S: TS31;
{  L: LongInt;}
 begin
{  L:=Round(nach*Faktor);
  wvsprintf(S,'Der Move-Befehl geht zu %ld',L);
  MessageBox(HWindow,S,'Motor-Start',0);}
  if MoveMotorQuiet(nach) then begin
   MoveMotor:=true;
  end else begin
   Real2S(Nach,3,S);
   Hinweis1(HWindow,ST_BadMove,S);
   MoveMotor:=false;
  end;
 end;

procedure TMain.CMMSel(var Msg:TMessage);
 begin
  if Application^.ExecDialog(New(PMSelDlg,
     Init(@Self,MakeIntResource(ID_MSel))))=ID_OK then begin
   SetScrollbars(0.0);	{rcksetzen}
   SetTextStrings(0.0);	{Text auf Fragezeichen}
   SetNewAlias;		{fr DDE}
   EnableButtons;
  end;
 end;

{*******************}
{Applikations-Objekt}
{*******************}
type
 PApp=^TApp;
 TApp=object(TApplication)
  procedure InitMainWindow; virtual;	{sonst wre es nur ein leeres Fenster}
 end;

procedure TApp.InitMainWindow;
 begin
  inherited InitMainWindow;
  MainWindow:=New(PMain,Init(nil,MakeIntResource(100)));
 end;

var
 App:TApp;

begin
 App.Init(AppName);
 App.Run;
 App.Done;
end.
