unit smsp;
{Sammlung diverser allgemeiner Unterprogramme zum Thema
 * Zahlen-Konvertierung
 * Zahlen-String-Konvertierung
 * Meldungsbox mit String-ID
 * Mul und Div (eher Selbstzweck)
}
{$C PRELOAD FIXED}
interface
uses WinProcs,WinTypes,Strings,WinDos,SMSH,UMSTEP;

function GetReal(HWindow:HWnd; ID: Word; var Z:TReal):boolean;

function Real2S(Z:TReal; F:Integer; S:PChar):PChar;
function S2Real(S:PChar; var Z: TReal):boolean;

function Hinweis(Wnd:HWnd; ID:Word; var p):Integer;
function Hinweis1(Wnd:HWnd; ID:Word; S:PChar):Integer; {1 arg}
{Notfalls auch 2 Integer-Argumente mit PChar(MakeLong(Par2,Par1)) }

procedure ShortYield;

function LongMul(F1,F2:Integer):LongInt;
 inline($5A/$58/$F7/$EA);	{pop dx; pop ax; imul dx}
function ULongMul(F1,F2:Word):LongInt;
 inline($5A/$58/$F7/$E2);	{pop dx; pop ax; mul dx}
function LongDiv(Z:LongInt; N:Integer):Integer;
 inline($59/$58/$5A/$F7/$F9);	{pop cx; pop ax; pop dx; idiv cx}
function ULongDiv(Z:LongInt; N:Word):Word;
 inline($59/$58/$5A/$F7/$F1);	{pop cx; pop ax; pop dx; div cx}
function ULongMod(Z:LongInt; N:Word):Word;
 inline($59/$58/$5A/$F7/$F1/$87/$C2);
 {pop cx; pop ax; pop dx; div cx; xchg ax,dx}

function GetDlgItemHex(Wnd:HWnd; ID:Word; var W:Word):Boolean;

procedure MotorCallback;

const
 AMotor:TMotor=(
  Handle:	0;
  CFlags:	MC_Trapeze or MC_Table;
  HWEMask:	1;
  HWEXor:	1;
  PortHWE:	$2C0;
  PortA:	$2C0;
  PortB:	$2C1;
  CallbackAddr:	@MotorCallback;
  CallbackDS:	Seg(HInstance);
  CallbackUser:	0;
  MaxSpeed:	48*65536;
  RefSpeed:	12*65536;
  MaxAccel:	48;
  Refpoint:	0;
  LeftBound:	-MaxLongInt;
  RightBound:	+MaxLongInt);

procedure SetMotorStruc;

implementation

function GetReal(HWindow:HWnd; ID: Word; var Z:TReal):boolean;
 var
  S: TS31;
 begin
  GetDlgItemText(HWindow,ID,S,sizeof(S));
  GetReal:=S2Real(S,Z);
 end;

function Real2S(Z:TReal; F:Integer; S:PChar):PChar;
{Diese Funktion arbeitet wie Str(Z:F:F,S), jedoch werden unntige
 Nachkommastellen (Nullen) abgeschnitten}
{STR erwartet String-Lngenangabe; daher mit wildem Typecast ruhigstellen}
 begin
  Str(Z:F:F,TS255(Pointer(S)^));	{mittels Systemfunktion wandeln}
  Real2S:=S;		{Stringzeiger durchreichen}
  S:=StrScan(S,'.');	{Dezimalpunkt enthalten?}
  if S<>nil then begin
   S:=StrEnd(S);	{Auf die Null}
   repeat
    Dec(S);		{Zeiger aufs Stringende (vor die Null)}
    if S^='.' then begin {String besteht nur (noch) aus dem Dezimalpunkt?}
     S^:=#0;		{String krzen und raus!}
     break;
    end;
    if S^='0' then S^:=#0	{Stringende ist die Null? - Krzen und weiter}
    else break;		{sonst raus!}
   until false;
  end;
 end;

function S2Real(S:PChar; var Z: TReal):boolean;
{wie Val(), jedoch vorher Komma zu Punkt wandeln}
{Weiraum (TAB & SPC) am Anfang wird bergangen, Weiraum (#0..' ')
 am Ende auch, beim Abhacken wird das Zeichen zwischendurch gemerkt.
 Achtung: Bei Fehler wird eine 0.0 in die Variable Z geschrieben!}
 var
  I:Integer;
  SP: PChar;
  MemChr: Char;
 begin
  while (S^=' ') or (S^=#9) do Inc(S);	{Weiraum am Anfang bergehen}
  SP:=StrScan(S,',');
  if SP<>nil then SP^:='.';	{Komma zum Punkt machen}
  SP:=S;
  while SP^>' ' do Inc(SP);	{Ende des Strings suchen}
  MemChr:=SP^; SP^:=#0;		{Zeichen merken, String abhacken}
  Val(S,Z,I);
  SP^:=MemChr;			{Zeichen zurckschreiben}
  S2Real:= (I=0);		{false wenn Fehler in Real-Zahl}
 end;

function Hinweis(Wnd:HWnd; ID:Word; var p):Integer;
{HINWEIS ldt einen String aus der Resource mit der entsprechenden ID und
zeigt ihn in einer Messagebox an. Da Resourcenstrings ein Lngenbyte haben,
dient ein eventuelles #0-Zeichen im String als Trenner zwischen Text und Titel}
 var
  S,S2: TS255;			{2 Puffer; leider so erforderlich}
  SPT,SPH: PChar;		{Zeiger auf Text und Titel}
  I,K: Integer;
  TextType:Word;
 begin
  TextType:=MB_OK or MB_IconExclamation;
  I:=LoadString(HInstance,ID,S,sizeof(S)); {I=Anzahl der Zeichen insgesamt}
  SPT:=S;
  if S[0]='$' then begin
   Val(S,TextType,K);
   SPT:=StrEnd(S)+1;
  end;
  SPH:=StrEnd(SPT)+1;
  if SPH-S>I then SPH:=nil;
  MessageBeep(TextType);
  wvsprintf(S2,S,P);
  Hinweis:=MessageBox(Wnd,S2,SPH,TextType);
 end;

function Hinweis1(Wnd:HWnd; ID:Word; S:PChar):Integer;
 begin
  Hinweis1:=Hinweis(Wnd,ID,S);
 end;

procedure ShortYield;
 var
  Msg: TMsg;
 begin
  if PeekMessage(Msg,0,0,0,PM_Remove) then begin
   TranslateMessage(Msg);
   DispatchMessage(Msg);
  end;
 end;

procedure MotorCallback; assembler;
 asm
	push	dx	{Window}
	push	cx	{Message}
	push	ax	{wParam=Flags und Handle}
	push	di
	push	si	{lParam=Position}
	call	PostMessage
 end;

procedure SetMotorStruc;
 var
  Freq: TReal;
  Swap: LongInt absolute Freq;
 begin
  Freq:=SMGetIntFreq;
  with MotorR do begin
   AMotor.MaxSpeed:=Round(Abs(MaxSpeed*256*65536*StepsPerUnit/Freq));
   AMotor.RefSpeed:=Round(RefSpeed*256*65536*StepsPerUnit/Freq);
   AMotor.MaxAccel:=Round(Abs(MaxAccel*256*65536*StepsPerUnit/sqr(Freq)));
   AMotor.Refpoint:=Round(RefPoint*256*StepsPerUnit);
   AMotor.LeftBound:=Round(LeftBound*256*StepsPerUnit);
   AMotor.RightBound:=Round(RightBound*256*StepsPerUnit);
  end;
  if AMotor.LeftBound>AMotor.RightBound then begin
   Swap:=AMotor.LeftBound;
   AMotor.LeftBound:=AMotor.RightBound;
   AMotor.RightBound:=Swap;	{Tauschen der Rnder}
  end;
 end;

function GetDlgItemHex(Wnd:HWnd; ID:Word; var W:Word):Boolean;
 var
  S: TS31;
  HW: Word;
  EC: Integer;
 begin
  GetDlgItemHex:=false;
  GetDlgItemText(Wnd,ID,S+1,sizeof(S)-1);
  S[0]:='$';
  Val(S,HW,EC);
  if EC=0 then begin
   W:=HW;
   GetDlgItemHex:=true;
  end;
 end;


end.
